﻿Imports System.Runtime.CompilerServices
Imports System.IO

Public Module StreamX
    ' Die Warnung ist zwar keine Summary, aber so wichtig, dass sie 
    '  in der Intellisense angezeigt werden soll
    ''' <summary>
    ''' Achtung! Bei endlosem ReadStream (z.B. System.Net.Sockets.NetworkStream) 
    '''  ist die Angabe von Count **erforderlich**, nicht optional!
    ''' </summary>
    Public Sub WriteTo( _
        ByVal ReadStream As Stream, _
        ByVal WriteStream As Stream, _
        Optional ByVal Count As Long = Long.MaxValue, _
        Optional ByVal Bufsize As Integer = Short.MaxValue)

        ' Hinweis für VB2008-Nutzer: Diese Sub ist eigentlich als 
        '  Extension der Stream-Klasse gedacht
        Dim Buf(Bufsize - 1) As Byte
        Dim ReadCount As Long = 0
        While Count > ReadCount
            Dim Portion As Integer = _
                ReadStream.Read(Buf, 0, _
                    CInt(Math.Min(Count - ReadCount, Bufsize)))
            If Portion = 0 Then
                If Count = Long.MaxValue Then Return
                Throw New ArgumentException(String.Concat( _
                    "StreamX.WriteTo(ReadStream, WriteStream, Count:=", _
                    Count, "): ReadStream konnte ", "nur ", ReadCount, _
                    " Bytes lesen"))
            End If
            ReadCount += Portion
            WriteStream.Write(Buf, 0, Portion)
        End While
    End Sub
End Module